VERSION 5.00
Begin VB.Form LPT_Form 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Parallel port monitor"
   ClientHeight    =   3900
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6135
   Icon            =   "LPT.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3900
   ScaleWidth      =   6135
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Poll 
      Interval        =   100
      Left            =   3120
      Top             =   1440
   End
   Begin VB.CommandButton AboutButton 
      Caption         =   "About"
      Height          =   375
      Left            =   4800
      TabIndex        =   62
      Top             =   1440
      Width           =   1215
   End
   Begin VB.Frame Frame4 
      Caption         =   "Parallel port:"
      Height          =   1215
      Left            =   3120
      TabIndex        =   59
      Top             =   0
      Width           =   2895
      Begin VB.OptionButton PortSelect 
         Caption         =   "LPT3:  278"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   61
         ToolTipText     =   "Parallel port 3"
         Top             =   840
         Width           =   1215
      End
      Begin VB.OptionButton PortSelect 
         Caption         =   "LPT2:  378"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   60
         ToolTipText     =   "Parallel port 2"
         Top             =   600
         Width           =   1215
      End
      Begin VB.OptionButton PortSelect 
         Caption         =   "LPT1:  3BC"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   1
         ToolTipText     =   "Parallel port 1"
         Top             =   360
         Width           =   1215
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "Control register:"
      Height          =   1815
      Left            =   3120
      TabIndex        =   24
      Top             =   2040
      Width           =   2895
      Begin VB.CheckBox ControlCheck 
         Caption         =   "Tristate outputs"
         Height          =   255
         Index           =   5
         Left            =   1200
         TabIndex        =   39
         ToolTipText     =   "Changes the data register to an input register"
         Top             =   1440
         Width           =   1455
      End
      Begin VB.CheckBox ControlCheck 
         Caption         =   "Interrupt enable"
         Height          =   255
         Index           =   4
         Left            =   1200
         TabIndex        =   38
         ToolTipText     =   "Generates an IRQ when pin 10 is set"
         Top             =   1200
         Width           =   1455
      End
      Begin VB.CheckBox ControlCheck 
         Caption         =   "Select input"
         Height          =   255
         Index           =   3
         Left            =   1200
         TabIndex        =   37
         Top             =   960
         Width           =   1455
      End
      Begin VB.CheckBox ControlCheck 
         Caption         =   "Initialise printer"
         Height          =   255
         Index           =   2
         Left            =   1200
         TabIndex        =   36
         Top             =   720
         Width           =   1455
      End
      Begin VB.CheckBox ControlCheck 
         Caption         =   "Auto line feed"
         Height          =   255
         Index           =   1
         Left            =   1200
         TabIndex        =   35
         Top             =   480
         Width           =   1455
      End
      Begin VB.CheckBox ControlCheck 
         Caption         =   "Strobe"
         Height          =   255
         Index           =   0
         Left            =   1200
         TabIndex        =   34
         Top             =   240
         Width           =   1455
      End
      Begin VB.Label bitLabel 
         Caption         =   "5"
         Height          =   255
         Index           =   18
         Left            =   960
         TabIndex        =   58
         Top             =   1440
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "4"
         Height          =   255
         Index           =   17
         Left            =   960
         TabIndex        =   57
         Top             =   1200
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "3"
         Height          =   255
         Index           =   16
         Left            =   960
         TabIndex        =   56
         Top             =   960
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "2"
         Height          =   255
         Index           =   15
         Left            =   960
         TabIndex        =   55
         Top             =   720
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "1"
         Height          =   255
         Index           =   14
         Left            =   960
         TabIndex        =   54
         Top             =   480
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "0"
         Height          =   255
         Index           =   13
         Left            =   960
         TabIndex        =   53
         Top             =   240
         Width           =   135
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 17"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Index           =   16
         Left            =   120
         TabIndex        =   28
         ToolTipText     =   "Pin 17 is inverted"
         Top             =   960
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 16"
         Height          =   255
         Index           =   15
         Left            =   120
         TabIndex        =   27
         Top             =   720
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 14"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Index           =   14
         Left            =   120
         TabIndex        =   26
         ToolTipText     =   "Pin 14 is inverted"
         Top             =   480
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 1"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Index           =   13
         Left            =   120
         TabIndex        =   25
         ToolTipText     =   "Pin 1 is inverted"
         Top             =   240
         Width           =   495
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Feedback register:"
      Height          =   1575
      Left            =   120
      TabIndex        =   18
      Top             =   2280
      Width           =   2895
      Begin VB.CheckBox FeedCheck 
         Caption         =   "Busy"
         Height          =   255
         Index           =   7
         Left            =   1320
         TabIndex        =   33
         Top             =   1200
         Width           =   1335
      End
      Begin VB.CheckBox FeedCheck 
         Caption         =   "Acknowledge"
         Height          =   255
         Index           =   6
         Left            =   1320
         TabIndex        =   32
         Top             =   960
         Width           =   1335
      End
      Begin VB.CheckBox FeedCheck 
         Caption         =   "Out of paper"
         Height          =   255
         Index           =   5
         Left            =   1320
         TabIndex        =   31
         Top             =   720
         Width           =   1335
      End
      Begin VB.CheckBox FeedCheck 
         Caption         =   "Select"
         Height          =   255
         Index           =   4
         Left            =   1320
         TabIndex        =   30
         Top             =   480
         Width           =   1335
      End
      Begin VB.CheckBox FeedCheck 
         Caption         =   "Error"
         Height          =   255
         Index           =   3
         Left            =   1320
         TabIndex        =   29
         Top             =   240
         Width           =   1335
      End
      Begin VB.Label bitLabel 
         Caption         =   "7"
         Height          =   255
         Index           =   12
         Left            =   1080
         TabIndex        =   52
         Top             =   1200
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "6"
         Height          =   255
         Index           =   11
         Left            =   1080
         TabIndex        =   51
         Top             =   960
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "5"
         Height          =   255
         Index           =   10
         Left            =   1080
         TabIndex        =   50
         Top             =   720
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "4"
         Height          =   255
         Index           =   9
         Left            =   1080
         TabIndex        =   49
         Top             =   480
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "3"
         Height          =   255
         Index           =   8
         Left            =   1080
         TabIndex        =   48
         Top             =   240
         Width           =   135
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 11"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Index           =   12
         Left            =   120
         TabIndex        =   23
         ToolTipText     =   "Pin 11 is inverted"
         Top             =   1200
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 10"
         Height          =   255
         Index           =   11
         Left            =   120
         TabIndex        =   22
         Top             =   960
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 12"
         Height          =   255
         Index           =   10
         Left            =   120
         TabIndex        =   21
         Top             =   720
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 13"
         Height          =   255
         Index           =   9
         Left            =   120
         TabIndex        =   20
         Top             =   480
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 15"
         Height          =   255
         Index           =   8
         Left            =   120
         TabIndex        =   19
         Top             =   240
         Width           =   495
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Data output register:"
      Height          =   2295
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   2895
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &0"
         Height          =   255
         Index           =   0
         Left            =   1320
         TabIndex        =   2
         Top             =   240
         Width           =   1335
      End
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &1"
         Height          =   255
         Index           =   1
         Left            =   1320
         TabIndex        =   3
         Top             =   480
         Width           =   1335
      End
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &2"
         Height          =   255
         Index           =   2
         Left            =   1320
         TabIndex        =   4
         Top             =   720
         Width           =   1335
      End
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &3"
         Height          =   255
         Index           =   3
         Left            =   1320
         TabIndex        =   5
         Top             =   960
         Width           =   1335
      End
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &4"
         Height          =   255
         Index           =   4
         Left            =   1320
         TabIndex        =   6
         Top             =   1200
         Width           =   1335
      End
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &5"
         Height          =   255
         Index           =   5
         Left            =   1320
         TabIndex        =   7
         Top             =   1440
         Width           =   1335
      End
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &6"
         Height          =   255
         Index           =   6
         Left            =   1320
         TabIndex        =   8
         Top             =   1680
         Width           =   1335
      End
      Begin VB.CheckBox DataCheck 
         Caption         =   "Data bit &7"
         Height          =   255
         Index           =   7
         Left            =   1320
         TabIndex        =   9
         Top             =   1920
         Width           =   1335
      End
      Begin VB.Label bitLabel 
         Caption         =   "7"
         Height          =   255
         Index           =   7
         Left            =   1080
         TabIndex        =   47
         Top             =   1920
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "6"
         Height          =   255
         Index           =   6
         Left            =   1080
         TabIndex        =   46
         Top             =   1680
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "5"
         Height          =   255
         Index           =   5
         Left            =   1080
         TabIndex        =   45
         Top             =   1440
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "4"
         Height          =   255
         Index           =   4
         Left            =   1080
         TabIndex        =   44
         Top             =   1200
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "3"
         Height          =   255
         Index           =   3
         Left            =   1080
         TabIndex        =   43
         Top             =   960
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "2"
         Height          =   255
         Index           =   2
         Left            =   1080
         TabIndex        =   42
         Top             =   720
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "1"
         Height          =   255
         Index           =   1
         Left            =   1080
         TabIndex        =   41
         Top             =   480
         Width           =   135
      End
      Begin VB.Label bitLabel 
         Caption         =   "0"
         Height          =   255
         Index           =   0
         Left            =   1080
         TabIndex        =   40
         Top             =   240
         Width           =   135
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 2"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   17
         Top             =   240
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 3"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   16
         Top             =   480
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 4"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   15
         Top             =   720
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 5"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   14
         Top             =   960
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 6"
         Height          =   255
         Index           =   4
         Left            =   120
         TabIndex        =   13
         Top             =   1200
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 7"
         Height          =   255
         Index           =   5
         Left            =   120
         TabIndex        =   12
         Top             =   1440
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 8"
         Height          =   255
         Index           =   6
         Left            =   120
         TabIndex        =   11
         Top             =   1680
         Width           =   495
      End
      Begin VB.Label PinLabel 
         Caption         =   "pin 9"
         Height          =   255
         Index           =   7
         Left            =   120
         TabIndex        =   10
         Top             =   1920
         Width           =   495
      End
   End
End
Attribute VB_Name = "LPT_Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Parallel port monitor

' PortAddress is the address of the data register.
' PortAddress+1 is the feedback register.
' PortAddress+2 is the control register.
Dim PortAddress As Integer
' Flag to keep track of self-inflicted events.
Dim Self As Boolean

' Show program information.
Private Sub AboutButton_Click()
  msg$ = "Parallel port monitor" + Chr$(13) + Chr$(13)
  msg$ = msg$ + "by Neil Fraser" + Chr$(13)
  msg$ = msg$ + "April 2003" + Chr$(13)
  msg$ = msg$ + "Inverness, Scotland" + Chr$(13) + Chr$(13)
  msg$ = msg$ + "http://neil.fraser.name" + Chr$(13)
  msg$ = msg$ + "root@neil.fraser.name"
  
  MsgBox msg$, vbInformation, "Parallel port monitor"
End Sub

' Change one bit in the control register.
Private Sub ControlCheck_Click(Index As Integer)
  If Self Then Exit Sub
  Dim register As Byte
  register = Inp(PortAddress + 2)
  register = register Xor 2 ^ Index
  Out PortAddress + 2, register
End Sub

' Change one bit in the data register.
Private Sub DataCheck_Click(Index As Integer)
  If Self Then Exit Sub
  If ControlCheck(5).Value = 1 Then Beep
  Dim register As Byte
  register = Inp(PortAddress)
  register = register Xor 2 ^ Index
  Out PortAddress, register
End Sub

' Changes to the feedback register are impossible.
Private Sub FeedCheck_Click(Index As Integer)
  If Not Self Then Beep
End Sub

' Start on parallel port #1.
Private Sub Form_Load()
  PortSelect(0).Value = True
End Sub

' Scan all three registers and update the display.
' Repeat ten times a second.
Private Sub Poll_Timer()
  Dim register As Byte
  Dim i As Byte
  Self = True ' avoid recursive changes
  ' Read data register
  register = Inp(PortAddress)
  For i = 0 To 7
    If register And 2 ^ i Then
      DataCheck(i).Value = 1
    Else
      DataCheck(i).Value = 0
    End If
  Next i
  ' Read feedback register
  register = Inp(PortAddress + 1)
  For i = 3 To 7
    If register And 2 ^ i Then
      FeedCheck(i).Value = 1
    Else
      FeedCheck(i).Value = 0
    End If
  Next i
  ' Read control register
  register = Inp(PortAddress + 2)
  For i = 0 To 5
    If register And 2 ^ i Then
      ControlCheck(i).Value = 1
    Else
      ControlCheck(i).Value = 0
    End If
  Next i
  Self = False
End Sub

' Change the parallel port.
Private Sub PortSelect_Click(Index As Integer)
  Select Case Index
  Case 0
    PortAddress = &H3BC
  Case 1
    PortAddress = &H378
  Case 2
    PortAddress = &H278
  End Select
End Sub
